﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ScheduleView;

namespace RadScheduleViewSpecialSlots
{
		public class MyViewModel: ViewModelBase
		{
				public ObservableCollection<Appointment> Appointments { set; get; }
				public ObservableCollection<Slot> SpecialSlots { set; get; }

				// ADDED CODE by bbee
				public ObservableCollection<ResourceType> ResourcesTypes { get; private set; }

				public MyViewModel()
				{
					Appointments = new ObservableCollection<Appointment>();
					SpecialSlots = new ObservableCollection<Slot>();

					var dtT = new DateTime(2012, 2, 21, 9, 0, 0);
					WorkingHourOccurence workingDayOcc = new WorkingHourOccurence(dtT, dtT.AddDays(1));
					//workingDayOcc.Start = dtT;
					//workingDayOcc.End = dtT.AddDays(1);
					workingDayOcc.Resources.Add(new Resource("Teacher1", "Calendar"));
					// workingDayOcc.Effort = 5.0;
					//the IsReadOnly property has to be set to the Slot in order to disable the editing of the slot
					workingDayOcc.IsReadOnly = true;
					//recurrence e Weekly
					workingDayOcc.RecurrencePattern = new RecurrencePattern(null, RecurrenceDays.WeekDays, RecurrenceFrequency.Weekly, 1, null, null);

					SpecialSlots.Add(workingDayOcc);

					// ADDED CODE by bbee: begin ------------------------
					ResourcesTypes = new ObservableCollection<ResourceType>();
					var resourceTypeCalendar = new ResourceType("Calendar");
					ResourcesTypes.Add(resourceTypeCalendar);

					// calendar for course appointments
					var resourceCourse = new Resource("Course");
					resourceTypeCalendar.Resources.Add(resourceCourse);

					// calendar for course appointments
					var resourceTeacher1 = new Resource("Teacher1");
					resourceTypeCalendar.Resources.Add(resourceTeacher1);

					// calendar for course appointments
					var resourceTeacher2 = new Resource("Teacher2");
					resourceTypeCalendar.Resources.Add(resourceTeacher2);

					var today = DateTime.Today;
					var appointment = new Appointment();
					appointment.UniqueId = Guid.NewGuid().ToString();
					appointment.Subject = "Course1";
					appointment.Start = today.AddHours(9);
					appointment.End = appointment.Start.AddHours(2);
					// appointment from course & teacher2
					appointment.Resources.Add(resourceCourse);
					appointment.Resources.Add(resourceTeacher1);
					Appointments.Add(appointment);

					appointment = new Appointment();
					appointment.UniqueId = Guid.NewGuid().ToString();
					appointment.Subject = "Course2";
					appointment.Start = today.AddDays(2).AddHours(8);
					appointment.End = appointment.Start.AddHours(4);
					// appointment from course
					appointment.Resources.Add(resourceCourse);
					Appointments.Add(appointment);

					appointment = new Appointment();
					appointment.UniqueId = Guid.NewGuid().ToString();
					appointment.Subject = "Private Appoinment";
					appointment.Start = today.AddDays(2).AddHours(7);
					appointment.End = appointment.Start.AddHours(8);
					// appointment from teacher2
					appointment.Resources.Add(resourceTeacher2);
					Appointments.Add(appointment);

					// ADDED CODE by bbee: end ------------------------

				}
		}
}
